-- made by VADemon
-- http://www.unrealsoftware.de/profile.php?userid=7844
-- http://steamcommunity.com/profiles/76561198033268090

env_safezone = {
	zones = {
		-- [1] = {startX, startY, endX, endY, "name"/nil}
	},
	isSafe = {
		-- [playerID] = SafeZone-ID/nil	-- if player is in safezone, this is the safezone ID else nil
	},
	imgIndicator = {
		-- [playerID] = imageID
	}
}


-- Initialize safezones
local list = entitylist()
for _,e in pairs(list) do
	local x, y = e.x, e.y

	--msg(k.. "- entity @ ("..e.x..","..e.y..") - "..entity(e.x,e.y,"typename"))
	if entity(x, y, "type") == 27 and string.find(string.lower(entity(x, y, "name")) or "", "safezone", 1, true) then
		local name = entity(x, y, "name"):match("safezone=(.+)")
		-- add to list
		table.insert(env_safezone.zones, {x, y, x+entity(x,y,"int2"), y+entity(x,y,"int3"), name})
		
		print("Env_Safezone: Added safezone '".. (name or "unnamed") .."' from ".. x .."|".. y .." to ".. x+entity(x,y,"int2") .."|"..y+entity(x,y,"int3"))
		
		-- entity state == false - DAMAGE ENABLED
		-- entity state == true - DAMAGE DISABLED
		
		-- if Env_Hurt is for damage, not heal and is enabled
		if entity(x,y,"int0") >= 0 and entity(x, y, "state") == false then
			-- disable hurt entity, no hurt plz
			print("Env_Safezone: Disabling entity at ".. x .."|".. y .." - correct behaviour")
			parse("triggerposition ".. x .." ".. y)
		else
			print("Env_Safezone: Disabled entity at ".. x .."|".. y .." - incorrect behaviour, should be enabled by default")
		end
	end
end

-- On Hit hook
addhook("hit", "env_safezone_hit")
function env_safezone_hit(victimId, sourceId, weapon, hpdmg, apdmg, rawdmg, objectId)
	if rawdmg > 0 then	-- only if player is DAMAGED in safe zone, for heals dmg<0 dont do anything
		
		--msg("Player ".. victimId .." was hit by source:".. sourceId .." with ".. weapon)
		
		local tilex, tiley = player(victimId, "tilex"), player(victimId, "tiley")
		
		
		-- is in safe zone?
		if env_safezone.isSafe[victimId] then
			
			local imageId = env_safezone.imgIndicator[victimId]
		
			imagescale(imageId, 2.5, 2.5)
			imagecolor(imageId, 120, 255, 255)
			tween_color(imageId, 500, 60, 255, 140)
			tween_scale(imageId, 400, 1.5, 1.5)
			--timer(500, "freeimage", imageId)
			
			--msg("Player is in safezone, no damage")
			return 1
		end
	end
end

addhook("movetile", "env_safezone_movetile")
function env_safezone_movetile(id, newx, newy)
	local isSafe = env_safezone.isSafe[id]
	
	if isSafe then	-- inside a zone right now
		-- check if outside
		local zone = env_safezone.zones[ env_safezone.isSafe[id] ]
		if newx < zone[1] or newy < zone[2] or newx >= zone[3] or newy >= zone[4] then
			local name = zone[5] or "a Safezone"
			msg2(id, "240160100You have left ".. name .."!@C")
			env_safezone.isSafe[id] = nil
			
			freeimage(env_safezone.imgIndicator[id])
		end
	
	else
		-- check if enters a new zone
		for i = 1, #env_safezone.zones do
			
			if newx >= env_safezone.zones[i][1] and newy >= env_safezone.zones[i][2] and 
				newx < env_safezone.zones[i][3] and newy < env_safezone.zones[i][4] then
				
				local name = env_safezone.zones[i][5] or "a Safezone"
				msg2(id, "060255140You have entered ".. name .."!@C")
				
				env_safezone.isSafe[id] = i
				
				local imageId = image("gfx/player/marker.bmp<b>", 0, 0, id+132)
				env_safezone.imgIndicator[id] = imageId
				imagescale(imageId, 1.5, 1.5)
				imagepos(imageId, 0, 0, 45)
				imagecolor(imageId, 60, 255, 140)
				
				return
			end
		end
	end
end